#include <SPI.h>
#include <SD.h>
#include <FTOLED.h>
#include <fonts/Droid_Sans_24.h>
#include <Wire.h>
#include "RTClib.h"
const int button = 6;                                           
const int motor = 22;
RTC_DS3231 rtc;
const byte pin_cs = 1;
const byte pin_dc = 5;
const byte pin_reset = 4;
const byte pin_sd_cs = 12;
const int FRAME_COUNT = 38;
const int FRAME_COUNT2 = 45;
const int FRAME_COUNT3 = 30;
OLED oled(pin_cs, pin_dc, pin_reset);
OLED_TextBox time(oled,35,40,128,32);
void setup() {
  SD.begin(pin_sd_cs);
  oled.begin();
  Wire.begin();
  rtc.begin();
  pinMode(button,INPUT_PULLUP);
  pinMode(motor, OUTPUT);
}

void loop() { 
if(digitalRead(button) == LOW){ 
  oled.clearScreen();
  oled.drawString(0,64, "  Breathing\n  Exercise", WHITE, BLACK);
  delay (2500);
  digitalWrite(motor, LOW);  
  while(digitalRead(button) == HIGH) {       
    oled.clearScreen();
    breathing_tech();
  }
  //digitalWrite(motor, LOW);
  File image = SD.open("001.bmp");
  oled.displayBMP(image, 0, 0);
  delay(10000);
  while(digitalRead(button) == HIGH) {
    uint32_t start = millis();
    for(int i = 0; i < FRAME_COUNT; i++) {
      char filename[20];
      snprintf(filename, sizeof(filename), "frames/%03d.bmp", i);
      File frame = SD.open(filename);
      oled.displayBMP(frame, 0, 0);
      frame.close();
     } 
   }
  File image2 = SD.open("002.bmp");
  oled.displayBMP(image2, 0, 0);
  delay(10000);
  oled.clearScreen();
  while(digitalRead(button) == HIGH) {
  uint32_t start = millis();
    for(int i = 0; i < FRAME_COUNT2; i++) {
      char filename[20];
      snprintf(filename, sizeof(filename), "frames3/%03d.bmp", i);
      File frame = SD.open(filename);
        oled.displayBMP(frame, 0, 0);
      frame.close();
    }
    }
File image3 = SD.open("000.bmp");
oled.displayBMP(image3, 0, 0);
delay(10000);
digitalWrite(motor, HIGH);
while(digitalRead(button) == HIGH) {
uint32_t start = millis();
  for(int i = 0; i < FRAME_COUNT3; i++) {
    char filename[20];
    snprintf(filename, sizeof(filename), "frames2/%03d.bmp", i);
    File frame = SD.open(filename);
     oled.displayBMP(frame, 0, 0);
    frame.close();
}
}
digitalWrite(motor, LOW);

}
   else
   
   {  
  mainclock();
   }

}

void breathing_tech()
{     
  oled.drawFilledBox(0,0,128,128,BLUE);
  digitalWrite(motor, HIGH);
  oled.drawString(0,64, "   Breathe\n     in\n     1", WHITE, BLUE);
  delay(2000);
  oled.drawString(0,64, "   Breathe\n     in\n     2", WHITE, BLUE);
  delay(2000);
  oled.drawString(0,64, "   Breathe\n     in\n     3", WHITE, BLUE);
  delay(2000);
  digitalWrite(motor, LOW);
  oled.drawFilledBox(0,0,128,128,GREEN);
  oled.drawString(0,64, "    Hold", WHITE, GREEN);
  delay(6000);
  oled.drawFilledBox(0,0,128,128,BLUE);
  digitalWrite(motor, HIGH);
  oled.drawString(0,64, "   Breathe\n    out\n     1", WHITE, BLUE);
  delay(2000);
  oled.drawString(0,64, "   Breathe\n    out\n     2", WHITE, BLUE);
  delay(2000);
  oled.drawString(0,64, "   Breathe\n    out\n     3", WHITE, BLUE);
  delay(2000);
  oled.drawFilledBox(0,0,128,128,BLUE);
  digitalWrite(motor, LOW);
  oled.drawString(20, 80, " Rest. .", WHITE, BLUE);
  delay(5000);
}


void mainclock()
{ 
  oled.drawString(29,105,"31/1/18   ", WHITE, BLACK);
  DateTime now = rtc.now();
  String writeString;
  time.setForegroundColour(WHITE);
  writeString = "";
  writeString += String(now.hour());
  writeString += ":";
  writeString += String(now.minute());
  oled.selectFont(Droid_Sans_24);
  time.print(writeString);
  time.reset();
  
   

 
}
